/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.common;

import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.csv.CSVParser;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

/**
 * ファイルアップロードに有用なメソッドを提供する。<br><br>
 * Multipartリクエストから、アップロードファイルやパラメータを取得する。
 */
public class FileUploadUtility {
	
	/**
	 * Multipartリクエストフィールド取得。<br>
	 * これにより取得したListを{@link #getMultipartField(List, String)}
	 * 及び{@link #getMultipartFile(List, String)}で利用する。<br>
	 * @param request リクエスト
	 * @return MultipartFieldList
	 * @throws Exception
	 */
	public static List<?> getMultipartFieldList(HttpServletRequest request) throws Exception {
		List<?> multipartFieldList = null;
		if (ServletFileUpload.isMultipartContent(request)) {
			DiskFileItemFactory factory = new org.apache.commons.fileupload.disk.DiskFileItemFactory();
			ServletFileUpload sfu = new org.apache.commons.fileupload.servlet.ServletFileUpload(factory);
			multipartFieldList = sfu.parseRequest(request);
		}
		return multipartFieldList;
	}
	
	/**
	 * Multipartリクエストフィールド取得。
	 * {@link #getMultipartFieldList(HttpServletRequest)}により取得した
	 * Listから、特定のフィールド(文字列)を取得する。<br>
	 * @param list  Multipartリクエストフィールドリスト
	 * @param param パラメータ名
	 * @return パラメーター値(Multipartでない場合、パラメータが無い場合はNULL)
	 * @throws Exception
	 */
	public static String getMultipartField(List<?> list, String param) throws Exception {
		if (list == null) {
			return null;
		}
		Iterator<?> iterator = list.iterator();
		while(iterator.hasNext()){
			FileItem item = (FileItem)iterator.next();
			if (item.isFormField()){
				if (item.getFieldName().equals(param)) {
					return new String(item.getString().getBytes("iso-8859-1"), MospConst.REQUEST_CHAR_ENC);
				}
			}
		}
		return null;
	}
	
	/**
	 * Multipartリクエストフィールド取得。<br>
	 * {@link #getMultipartFieldList(HttpServletRequest)}により取得した
	 * Listから、特定のフィールド(ファイル)を取得する。<br>
	 * @param list  Multipartリクエストフィールドリスト
	 * @param param パラメータ名
	 * @return パラメーター値(Multipartでない場合、パラメータが無い場合はNULL)
	 * @throws Exception
	 */
	public static FileItem getMultipartFile(List<?> list, String param) throws Exception {
		if (list == null) {
			return null;
		}
		Iterator<?> iterator = list.iterator();
		while(iterator.hasNext()){
			FileItem item = (FileItem)iterator.next();
			if (!item.isFormField()){
				if (item.getFieldName().equals(param)) {
					return item;
				}
			}
		}
		return null;
	}
	
	/**
	 * CSVデータパース。<br>
	 * commons-csvライブラリーを用いて、CSVデータパーサーを取得する。<br>
	 * commons-fileuploadライブラリーを用いてリクエストから取得したCSVファイルをパースする。<br>
	 * @param filCsv FileItemオブジェクト
	 * @return CSVファイル内容
	 * @throws Exception
	 */
	public static CSVParser parseCSVData(FileItem filCsv) throws Exception {
		CSVParser csvParseData = new CSVParser(
				new InputStreamReader(filCsv.getInputStream(), MospConst.REQUEST_CHAR_ENC));
		return csvParseData;
	}

}
